/***************************************************************************
                          debugdialog.cpp  -  description
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id$
 *
 */

#include "qtabman.h"

DebugDialog::DebugDialog(QWidget *parent,char *label)
		: QDialog( NULL, label, FALSE,WStyle_NormalBorder )
{

	this->setCaption ( "Debug Messages" ) ;
	debugmessages = new ScrollText(this,NULL);
	debugmessages->setAutoUpdate (TRUE);
	clear = new QPushButton( "Clear", this );
	clear->setDefault(TRUE);
	hidebutton = new QPushButton( "Hide", this );
	
	connect( hidebutton, SIGNAL(clicked()), SLOT(hide()) );
	connect( clear, SIGNAL(clicked()), SLOT(ClearMessages()) );
}

DebugDialog::~DebugDialog()
{
	emit this->Closed();
}

void DebugDialog::resizeEvent(QResizeEvent * r_event)
{
	/* resize the textbox */
	debugmessages->setGeometry(5,5,r_event->size().width()-10,r_event->size().height()-45);
	
	/* reposition the clear button */
	clear->setGeometry((r_event->size().width()/2)-65 ,r_event->size().height()-35, 60,30 );
	hidebutton->setGeometry((r_event->size().width()/2)+5 ,r_event->size().height()-35, 60,30 );

	QDialog::resizeEvent(r_event);
}

void DebugDialog::hideEvent(QHideEvent *h)
{
	emit this->Closed();
	QDialog::hideEvent(h);
}

void DebugDialog::InsertDebugText(QString debugmessage)
{
	//qDebug("Insert Debugstring '%s'",(const char*)debugmessage);
	debugmessages->append(debugmessage);
}

void DebugDialog::ClearMessages()
{
	debugmessages->clear();
}
