/***************************************************************************
                          prototypes.h  -  description
                             -------------------
    begin                : Sat Jan 8 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id$
 *
 */

/* oragetlib prototypes */
int ConnectToOracle(const char *,const char *,const char *,char **ant);
int ConnectToOracleByString(const char *conn,char **ant);
void DisconnectFromOracle();
int GetUserObjects(char ***data1,char ***data2,char ***data3,char ***data4,const char *type,int *aantal,char **resp);
int GetUserTables(char ***data1,char ***data2,int *aantal,char **resp);
int GetIndexDetails(char ***data1,char ***data2,const char *index,int *aantal,char **resp);
int GetUserIndexes(char ***data1,char ***data2,char ***data3,char ***data4,int *aantal,char **resp);
int GetUserObjectsName(char ***data1,const char *type,int *aantal,char **resp);
int GetAllUserObjects(char ***data1,char ***data2,char ***data3,char ***data4,int *aantal,char **resp);
int GetTableColumns(char ***data,const char *table,int *aantal,char **resp);
int GetTableIndexDetails(char ***data1,char ***data2,char ***data3,char ***data4,const char *table,int *aantal,char **resp);
int GetTableConstraintDetails(char ***data1,char ***data2,char ***data3,char ***data4,const char *table,int *aantal,char **resp);
int GetTableTriggerDetails(char ***data1,char ***data2,char ***data3,char ***data4,const char *table,int *aantal,char **resp);
int GetPackageBodyNames(char ***data1,char ***data2,char ***data3,const char *package,int *aantal,char **resp);
int GetTableColumnDetails(char ***data1,char ***data2,char ***data3,char ***data4,const char *table,int *aantal,char **resp);
int GetBodyArguments(char ***data1,char ***data2,char ***data3,char ***data4,const char *package,const char *body,const char *ol,int *aantal,char **resp);
int GetProcedureArguments(char ***data1,char ***data2,char ***data3,char ***data4,const char *procedure,int *aantal,char **resp);
int GetSchemaName(char *schema,char **err);

/* oratabman.pc prototypes */
int ReadFromPipe(const char *pipe,char* type,char *message,char** resp);
int SendToPipe(const char *pipe,const char* type,char *message,char** resp);
int DropColumn(char* column,char *table,char *owner,char* pipe,char **resp);
int DropTable(char* tn,char *own,char* pipe,char **resp);
int DropIndex(char* in,char *own,char* pipe,char **resp);
int DropTrigger(char* tr,char *own,char* pipe,char **resp);
int DropConstraint(char* con,char *own,char* pipe,char **resp);
int AlterTable(char *pipe,char *tn,char *own,char *new_tn,char* new_own,char* tablespace,
				long pct_free ,long pct_used ,long pct_incr ,
				long next_extent ,long min_extents ,long max_extents ,long max_trans,
				long ini_trans ,long initial_extent ,
				long free_lists ,long free_list_groups ,char **err);
int GetVersion(char *version,char **err);
int ExecDdl(const char* stmt,const char* pipe,char **resp);

/* oraproplib prototypes */
int GetTableProperties(const char *tn,const char *own,char* tablespace,long *pct_free ,long *pct_used ,long *pct_incr ,
				long *next_extent ,long *min_extents ,long *max_extents ,long *max_trans ,
				long *ini_trans ,long *initial_extent ,
				long *free_lists ,long *free_list_groups ,char **err);
int GetTableStats(const char *tn,const char *own,
			long *rowcount ,
			long *chained_rows ,
			long *avg_row_len ,
			long *blocks_on_freelist ,
			long *avg_free_space ,
			long *blocks_not_used ,
			long *blocks_used ,
			char *last_analyze ,
			long *sample_size ,char **err);


/* other prototypes */
void Debug(char *format,...);
void Signal(int i);