/***************************************************************************
                          tabledialog.cpp  -  description
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id$
 *
 */

#include "qtabman.h"

TableDialog::TableDialog( QString tname,QString towner,QWidget *parent, const char *name )
        : QDialog( NULL, name, FALSE )
{	
	int label_x_offset=20;
	int label_y_offset=20;
	int label_len=100;
	int label_hi=20;
	int label_spacing=5;
	
	int text_x_offset=label_x_offset+label_len+10;
	int text_y_offset=label_y_offset;
	int text_len=150;
	int text_hi=20;
	int text_spacing=label_spacing;
	
	int button_len=70;
	int button_hi=25;
	int button_offset=30;
	
	int prop_x_offset = 10;
	int prop_y_offset = 80;
	int prop_hi = 435;
	int prop_len = text_x_offset+text_len+10;
	
	int stat_x_offset = prop_x_offset + prop_len + 10;
	int stat_y_offset = prop_y_offset;
	int stat_hi = prop_hi;
	int stat_len = 300;
	
	
	QLabel *l_tablename = new QLabel(QString("Table name"),this);
	QLabel *l_owner = new QLabel(QString("Table owner"),this);
	l_tablename->setGeometry(label_x_offset,label_y_offset,label_len,label_hi);
	l_owner->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing),label_len,label_hi);

	tablename = new QLineEdit(this,NULL);
	owner = new QLineEdit(this,NULL);
	tablename->setEnabled(FALSE);
	owner->setEnabled(FALSE);
	tablename->setGeometry(text_x_offset,text_y_offset,text_len,text_hi);
	owner->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing),text_len,text_hi);

	/* create and size the frames */
	properties = new QGroupBox("Properties",this,"properties");
	statistics = new QGroupBox("Statistics",this,"statistics");
	properties->setGeometry(prop_x_offset,prop_y_offset,prop_len,prop_hi);
	statistics->setGeometry(stat_x_offset,stat_y_offset,stat_len,stat_hi);
	
	/* create the labels */
	QLabel *l_new_tablename = new QLabel(QString("New name"),properties);
	QLabel *l_new_owner = new QLabel(QString("New owner"),properties);
	QLabel *l_tablespace = new QLabel(QString("Tablespace"),properties);
	QLabel *l_pct_used = new QLabel(QString("Pct Used"),properties);
	QLabel *l_pct_free = new QLabel(QString("Pct Free"),properties);
	QLabel *l_pct_incr = new QLabel(QString("Pct Increase"),properties);
	QLabel *l_next_extent = new QLabel(QString("Next extent"),properties);
	QLabel *l_min_extents = new QLabel(QString("Min extents"),properties);
	QLabel *l_max_extents = new QLabel(QString("Max extents"),properties);
	QLabel *l_max_trans = new QLabel(QString("Max trans"),properties);
	QLabel *l_ini_trans = new QLabel(QString("Init trans"),properties);
	QLabel *l_initial_extent = new QLabel(QString("Initial extent"),properties);
	QLabel *l_free_lists = new QLabel(QString("Free lists"),properties);
	QLabel *l_free_list_groups = new QLabel(QString("Free list groups"),properties);

	QLabel *l_rowcount = new QLabel(QString("Rows"),statistics);
	QLabel *l_chained_rows = new QLabel(QString("Chained rows"),statistics);
	QLabel *l_avg_row_len = new QLabel(QString("Avg. row length"),statistics);
	QLabel *l_blocks_on_freelist = new QLabel(QString("Blocks on freelist"),statistics);
	QLabel *l_avg_free_space = new QLabel(QString("Avg. free space"),statistics);
	QLabel *l_blocks_not_used = new QLabel(QString("Blocks not used"),statistics);
	QLabel *l_blocks_used = new QLabel(QString("Blocks used"),statistics);
	QLabel *l_last_analyze = new QLabel(QString("Last analyze"),statistics);
	QLabel *l_sample_size = new QLabel(QString("Sample size (%)"),statistics);


	/* Create the textboxes */	
	new_tablename = new QLineEdit(properties,NULL);
	new_owner = new QLineEdit(properties,NULL);
	tablespace = new QLineEdit(properties,NULL);
	pct_used = new QLineEdit(properties,NULL);
	pct_free = new QLineEdit(properties,NULL);
	pct_incr = new QLineEdit(properties,NULL);
	next_extent = new QLineEdit(properties,NULL);
	min_extents = new QLineEdit(properties,NULL);
	max_extents = new QLineEdit(properties,NULL);
	max_trans = new QLineEdit(properties,NULL);
	ini_trans = new QLineEdit(properties,NULL);
	initial_extent = new QLineEdit(properties,NULL);
	free_lists = new QLineEdit(properties,NULL);
	free_list_groups = new QLineEdit(properties,NULL);

	rowcount = new QLineEdit(statistics,NULL);
	chained_rows = new QLineEdit(statistics,NULL);
	avg_row_len = new QLineEdit(statistics,NULL);
	blocks_on_freelist = new QLineEdit(statistics,NULL);
	avg_free_space = new QLineEdit(statistics,NULL);
	blocks_not_used = new QLineEdit(statistics,NULL);
	blocks_used = new QLineEdit(statistics,NULL);
	last_analyze = new QLineEdit(statistics,NULL);
	sample_size = new QLineEdit(statistics,NULL);
	
	/* unable text items */
	rowcount->setEnabled(FALSE);
	chained_rows->setEnabled(FALSE);
	avg_row_len->setEnabled(FALSE);
	blocks_on_freelist->setEnabled(FALSE);
	avg_free_space->setEnabled(FALSE);
	blocks_not_used->setEnabled(FALSE);
	blocks_used->setEnabled(FALSE);
	last_analyze->setEnabled(FALSE);

	/* Size labels */
	l_new_tablename->setGeometry(label_x_offset,label_y_offset,label_len,label_hi);
	l_new_owner->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing),label_len,label_hi);
	l_tablespace->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*2,label_len,label_hi);
	l_pct_used->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*3,label_len,label_hi);
	l_pct_free->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*4,label_len,label_hi);
	l_pct_incr->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*5,label_len,label_hi);
	l_next_extent->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*6,label_len,label_hi);
	l_min_extents->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*7,label_len,label_hi);
	l_max_extents->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*8,label_len,label_hi);
	l_max_trans->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*9,label_len,label_hi);
	l_ini_trans->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*10,label_len,label_hi);
	l_initial_extent->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*11,label_len,label_hi);
	l_free_lists->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*12,label_len,label_hi);
	l_free_list_groups->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*13,label_len,label_hi);
	
	l_rowcount->setGeometry(label_x_offset,label_y_offset,label_len,label_hi);
	l_chained_rows->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*1,label_len,label_hi);
	l_avg_row_len->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*2,label_len,label_hi);
	l_blocks_on_freelist->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*3,label_len,label_hi);
	l_avg_free_space->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*4,label_len,label_hi);
	l_blocks_not_used->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*5,label_len,label_hi);
	l_blocks_used->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*6,label_len,label_hi);
	l_last_analyze->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*7,label_len,label_hi);
	l_sample_size->setGeometry(label_x_offset,label_y_offset+(label_hi+label_spacing)*8,label_len,label_hi);

	/* size text items */
	new_tablename->setGeometry(text_x_offset,text_y_offset,text_len,text_hi);
	new_owner->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing),text_len,text_hi);
	tablespace->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*2,text_len,text_hi);
	pct_used->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*3,text_len,text_hi);
	pct_free->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*4,text_len,text_hi);
	pct_incr->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*5,text_len,text_hi);
	next_extent->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*6,text_len,text_hi);
	min_extents->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*7,text_len,text_hi);
	max_extents->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*8,text_len,text_hi);
	max_trans->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*9,text_len,text_hi);
	ini_trans->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*10,text_len,text_hi);
	initial_extent->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*11,text_len,text_hi);
	free_lists->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*12,text_len,text_hi);
	free_list_groups->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*13,text_len,text_hi);

	rowcount->setGeometry(text_x_offset,text_y_offset,text_len,text_hi);
	chained_rows->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing),text_len,text_hi);
	avg_row_len->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*2,text_len,text_hi);
	blocks_on_freelist->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*3,text_len,text_hi);
	avg_free_space->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*4,text_len,text_hi);
	blocks_not_used->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*5,text_len,text_hi);
	blocks_used->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*6,text_len,text_hi);
	last_analyze->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*7,text_len,text_hi);
	sample_size->setGeometry(text_x_offset,text_y_offset+(text_hi+text_spacing)*8,text_len,text_hi);
	
	/* Buttons */
	revert = new QPushButton( "Revert", properties );
	revert->setGeometry(prop_len/2-button_len/2,text_y_offset+(text_hi+text_spacing)*15,button_len,button_hi);
	
	cancel = new QPushButton( "Cancel", this );
	cancel->setGeometry(stat_x_offset+stat_len-button_len,stat_y_offset+stat_hi+text_spacing,button_len,button_hi);
	
	ok = new QPushButton( "Ok", this );
	ok->setGeometry(stat_x_offset+stat_len-((button_len*2)+text_spacing),stat_y_offset+stat_hi+text_spacing,button_len,button_hi);


	analyze = new QPushButton( "analyze", statistics );
	analyze->setGeometry(prop_len/2-button_len/2,text_y_offset+(text_hi+text_spacing)*10,button_len,button_hi);
	
	
	/* Connect signals */
	connect( ok, SIGNAL(clicked()), SLOT(DoAlterTable()) );
	connect( cancel, SIGNAL(clicked()), SLOT(hide()) );
	connect( revert, SIGNAL(clicked()), SLOT(RefreshProperties()) );
	connect( analyze, SIGNAL(clicked()), SLOT(AnalyzeTable()) );

	connect( new_tablename, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( new_owner, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( tablespace, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( pct_used, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( pct_free, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( pct_incr, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( next_extent, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( min_extents, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( max_extents, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( max_trans, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( initial_extent, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( free_lists, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( free_list_groups, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );
	connect( ini_trans, SIGNAL(textChanged(const QString&)), SLOT(UserMadeChanges(const QString&)) );

	this->resize(620,565);
	if(!tname.isEmpty()&&!towner.isEmpty())
		this->SetTableName(tname,towner);
}

TableDialog::~TableDialog()
{
	emit this->Closed();
}

void TableDialog::DoAlterTable()
{

	char *err;
	ApplicationWindow *wind;
	char username[31];
	char password[31];
	char database[31];
	char tn[31];
	char own[31];
	char new_tn[31];
	char new_own[31];
	char tablespace[31];
	long pct_free ;
	long pct_used ;
	long pct_incr ;
	long next_extent ;
	long min_extents ;
	long max_extents ;
	long max_trans ;
	long ini_trans ;
	long initial_extent ;
	long free_lists ;
	long free_list_groups ;
	/* get a pointer to the main application window */
	wind = (ApplicationWindow*)qApp->mainWidget();

	/* ask confirmation */
	if (QMessageBox::warning(this,"Qtabman","Change the table properties ?","&Yes","&No",0,0, 1 ))
		return;
		
	/* show the tabman dialog */
	wind->ShowTabmanDialog();	
	
	strcpy(username,(const char*)wind->username);
	strcpy(password,(const char*)wind->password);
	strcpy(database,(const char*)wind->database);

	strcpy(tn,(const char*)this->tablename->text());
	strcpy(new_tn,(const char*)this->new_tablename->text());
	strcpy(own,(const char*)this->owner->text());
	strcpy(new_own,(const char*)this->new_owner->text());

	strcpy(tablespace,(const char*)this->tablespace->text());
	pct_free =this->pct_free->text().toLong();
	pct_used =this->pct_used->text().toLong();
	pct_incr =this->pct_incr->text().toLong();
	next_extent =this->next_extent->text().toLong();
	min_extents =this->min_extents->text().toLong();
	max_extents =this->max_extents->text().toLong();
	max_trans =this->max_trans->text().toLong();
	ini_trans =this->ini_trans->text().toLong();
	initial_extent =this->initial_extent->text().toLong();
	free_lists =this->free_lists->text().toLong();
	free_list_groups =this->free_list_groups->text().toLong();


	/* Alter the table */
	if( fork() ==0)
	{
                if(ConnectToOracle(username,password,database,&err))
                {
		
			if(!AlterTable("TABMANPIPE",
					tn,
					own,
					new_tn,
					new_own,
					tablespace,
					pct_free,
					pct_used,
					pct_incr,
					next_extent,
					min_extents,
					max_extents,
					max_trans,
					ini_trans,
					initial_extent,
					free_lists,
					free_list_groups,
					&err) )
			{
				if(!SendToPipe("TABMANPIPE","QTABMAN",err,&err))
                                	qDebug("ERROR in SendToPipe : %s",err);
			}
		}
		exit(0);
	}
}

void TableDialog::SetTableName(QString name,QString owner)
{
	QString dialogtitle;
	this->tablename->setText(name);
	this->owner->setText(owner);
	dialogtitle= QString("Properties for : ") + this->owner->text() + QString(".") + this->tablename->text();
	this->setCaption(dialogtitle);
	this->RefreshProperties();
	this->GetTableStatistics();
}

void TableDialog::RefreshProperties()
{
	char *err;
	
	char tablespace[31] ;
	long pct_free ;
	long pct_used ;
	long pct_incr ;
	long next_extent ;
	long min_extents ;
	long max_extents ;
	long max_trans ;
	long ini_trans ;
	long initial_extent ;
	long free_lists ;
	long free_list_groups ;
	Debug("Refresh properties for %s owned by %s",(const char*)this->tablename->text(),(const char*)this->owner->text());
	if(GetTableProperties((const char*)this->tablename->text(),(const char*)this->owner->text(),
				tablespace,
				&pct_free ,
				&pct_used ,
				&pct_incr ,
				&next_extent ,
				&min_extents ,
				&max_extents ,
				&max_trans ,
				&ini_trans ,
				&initial_extent ,
				&free_lists ,
				&free_list_groups ,
				&err) )
	{
		/* enter the props */
		this->new_tablename->setText(this->tablename->text());
		this->new_owner->setText(this->owner->text());
		this->tablespace->setText(QString(tablespace));
		this->pct_free->setText(tr("%1").arg(pct_free));
		this->pct_used->setText(tr("%1").arg(pct_used));
		this->pct_incr->setText(tr("%1").arg(pct_incr));
		this->next_extent->setText(tr("%1").arg(next_extent));
		this->min_extents->setText(tr("%1").arg(min_extents));
		this->max_extents->setText(tr("%1").arg(max_extents));
		this->max_trans->setText(tr("%1").arg(max_trans));
		this->ini_trans->setText(tr("%1").arg(ini_trans));
		this->initial_extent->setText(tr("%1").arg(initial_extent));
		this->free_lists->setText(tr("%1").arg(free_lists));
		this->free_list_groups->setText(tr("%1").arg(free_list_groups));
	
		this->ok->setEnabled(FALSE);
		this->revert->setEnabled(FALSE);
	}
	else
		QMessageBox::message("Error",err);
				
}


void TableDialog:: GetTableStatistics()
{
	char *err;
	
	char tablespace[31] ;
	long rowcount ;
	long chained_rows ;
	long avg_row_len ;
	long blocks_on_freelist ;
	long avg_free_space ;
	long blocks_not_used ;
	long blocks_used ;
	char last_analyze[20] ;
	long sample_size ;
	Debug("Get statistics for %s owned by %s",(const char*)this->tablename->text(),(const char*)this->owner->text());
	
	if(GetTableStats((const char*)this->tablename->text(),(const char*)this->owner->text(),
				&rowcount ,
				&chained_rows ,
				&avg_row_len ,
				&blocks_on_freelist ,
				&avg_free_space ,
				&blocks_not_used ,
				&blocks_used ,
				last_analyze ,
				&sample_size ,
				&err) )
	{
		/* enter the props */
		this->rowcount->setText(tr("%1").arg(rowcount));
		this->chained_rows->setText(tr("%1").arg(chained_rows));
		this->avg_row_len->setText(tr("%1").arg(avg_row_len));
		this->blocks_on_freelist->setText(tr("%1").arg(blocks_on_freelist));
		this->avg_free_space->setText(tr("%1").arg(avg_free_space));
		this->blocks_not_used->setText(tr("%1").arg(blocks_not_used));
		this->blocks_used->setText(tr("%1").arg(blocks_used));
		this->last_analyze->setText(QString(last_analyze));
		this->sample_size->setText(tr("%1").arg(sample_size));
				
	}
	else
		QMessageBox::message("Error",err);
				
}

void TableDialog::AnalyzeTable()
{
	QString stmt;
	char *err;
	
	QApplication::setOverrideCursor( waitCursor );
	stmt = "ANALYZE TABLE "+this->tablename->text()+" ESTIMATE STATISTICS SAMPLE "+this->sample_size->text()+" PERCENT";
	if(!ExecDdl( (const char*) stmt,"TABMANPIPE",&err) )
	{
		QMessageBox::message("Error",err);
		free (err);
	}
	else
		this->GetTableStatistics();
		
	/* restore cursor */
	QApplication::restoreOverrideCursor();
}

void TableDialog::UserMadeChanges(const QString&)
{
	this->ok->setEnabled(TRUE);
	this->revert->setEnabled(TRUE);
}

void TableDialog::hideEvent(QHideEvent *h)
{
	emit this->Closed();
	QDialog::hideEvent(h);
}

void TableDialog::resizeEvent(QResizeEvent * r_event)
{
	QDialog::resizeEvent(r_event);
	this->setMaximumSize(this->size());
	this->setMinimumSize(this->size());
}
