/***************************************************************************
                          tabmandialog.cpp  -  description
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Joris Struyve
    email                : j.struyve@village.uunet.be
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/* CVS information :
 *
 * $Id$
 *
 */

#include "qtabman.h"

TabmanDialog::TabmanDialog(QWidget *parent,char *label)
		: QDialog( NULL, label, FALSE,WStyle_NormalBorder )
{

	this->setCaption ( "Tabman Messages" ) ;
	timer = new QTimer( this );
	blinker = new QLabel(this,NULL);
	blinker->setBackgroundColor(QColor(255,0,0));
	tabmanmessages = new ScrollText(this,NULL);
	tabmanmessages->setAutoUpdate (TRUE);
	clear = new QPushButton( "Clear", this );
	clear->setDefault(TRUE);
	hidebutton = new QPushButton( "Hide", this );
	
	connect( clear, SIGNAL(clicked()), SLOT(ClearMessages()) );
	connect( hidebutton, SIGNAL(clicked()), SLOT(hide()) );
	connect( timer, SIGNAL(timeout()), SLOT(BlinkTimer()) );
}

TabmanDialog::~TabmanDialog()
{
	emit this->Closed();
}

void TabmanDialog::resizeEvent(QResizeEvent * r_event)
{
	/* resize the textbox */
	tabmanmessages->setGeometry(5,5,r_event->size().width()-10,r_event->size().height()-45);
	
	/* reposition the clear button */
	clear->setGeometry((r_event->size().width()/2)-65 ,r_event->size().height()-35, 60,30 );
	hidebutton->setGeometry((r_event->size().width()/2)+5 ,r_event->size().height()-35, 60,30 );
	
	/* reposition the blinker label */
	blinker->setGeometry(r_event->size().width()-15 ,r_event->size().height()-15, 10,10 );
	
	QDialog::resizeEvent(r_event);
}

void TabmanDialog::hideEvent(QHideEvent *h)
{
	emit this->Closed();
	QDialog::hideEvent(h);
}

void TabmanDialog::InsertTabmanText(QString tabmanmessage)
{
	//qTabman("Insert Tabmanstring '%s'",(const char*)tabmanmessage);
	tabmanmessages->append(tabmanmessage);
}

void TabmanDialog::ClearMessages()
{
	tabmanmessages->clear();
}

void TabmanDialog::Blink()
{
	this->blinker->setBackgroundColor(QColor(255,0,0));
	this->blinker->repaint();
	timer->start( 20, TRUE );
}

void TabmanDialog::BlinkTimer()
{
	this->blinker->setBackgroundColor(QColor(0,255,0));
	this->blinker->repaint();
}

